Index: serefpolicy-contrib-20140730/daemontools.te
===================================================================
--- serefpolicy-contrib-20140730.orig/daemontools.te
+++ serefpolicy-contrib-20140730/daemontools.te
@@ -44,7 +44,10 @@ allow svc_multilog_t svc_start_t:process
 allow svc_multilog_t svc_start_t:fd use;
 allow svc_multilog_t svc_start_t:fifo_file rw_fifo_file_perms;
 
+term_write_console(svc_multilog_t)
+
 init_use_fds(svc_multilog_t)
+init_dontaudit_use_script_fds(svc_multilog_t)
 
 logging_manage_generic_logs(svc_multilog_t)
 
@@ -77,7 +80,8 @@ dev_read_urand(svc_run_t)
 corecmd_exec_bin(svc_run_t)
 corecmd_exec_shell(svc_run_t)
 
-files_read_etc_files(svc_run_t)
+term_write_console(svc_run_t)
+
 files_read_etc_runtime_files(svc_run_t)
 files_search_pids(svc_run_t)
 files_search_var_lib(svc_run_t)
@@ -109,6 +113,7 @@ allow svc_start_t svc_run_t:process { si
 
 can_exec(svc_start_t, svc_start_exec_t)
 
+mmap_files_pattern(svc_start_t, svc_svc_t, svc_svc_t)
 domtrans_pattern(svc_start_t, svc_run_exec_t, svc_run_t)
 
 kernel_read_kernel_sysctls(svc_start_t)
@@ -117,11 +122,13 @@ kernel_read_system_state(svc_start_t)
 corecmd_exec_bin(svc_start_t)
 corecmd_exec_shell(svc_start_t)
 
-files_read_etc_files(svc_start_t)
+corenet_tcp_bind_generic_node(svc_start_t)
+corenet_tcp_bind_generic_port(svc_start_t)
+
+term_write_console(svc_start_t)
+
 files_read_etc_runtime_files(svc_start_t)
 files_search_var(svc_start_t)
 files_search_pids(svc_start_t)
 
 logging_send_syslog_msg(svc_start_t)
-
-miscfiles_read_localization(svc_start_t)
Index: serefpolicy-contrib-20140730/dante.te
===================================================================
--- serefpolicy-contrib-20140730.orig/dante.te
+++ serefpolicy-contrib-20140730/dante.te
@@ -53,7 +53,6 @@ dev_read_sysfs(dante_t)
 
 domain_use_interactive_fds(dante_t)
 
-files_read_etc_files(dante_t)
 files_read_etc_runtime_files(dante_t)
 
 fs_getattr_all_fs(dante_t)
Index: serefpolicy-contrib-20140730/dbadm.te
===================================================================
--- serefpolicy-contrib-20140730.orig/dbadm.te
+++ serefpolicy-contrib-20140730/dbadm.te
@@ -23,14 +23,14 @@ gen_tunable(dbadm_read_user_files, false
 
 role dbadm_r;
 
-userdom_base_user_template(dbadm)
+userdom_confined_admin_template(dbadm)
 
 ########################################
 #
 # Local policy
 #
 
-allow dbadm_t self:capability { dac_override dac_read_search sys_ptrace };
+allow dbadm_t self:capability { dac_override dac_read_search };
 
 files_dontaudit_search_all_dirs(dbadm_t)
 files_delete_generic_locks(dbadm_t)
@@ -39,6 +39,7 @@ files_list_var(dbadm_t)
 selinux_get_enforce_mode(dbadm_t)
 
 logging_send_syslog_msg(dbadm_t)
+logging_send_audit_msgs(dbadm_t)
 
 userdom_dontaudit_search_user_home_dirs(dbadm_t)
 
@@ -60,3 +61,7 @@ optional_policy(`
 optional_policy(`
 	postgresql_admin(dbadm_t, dbadm_r)
 ')
+
+optional_policy(`
+	sudo_role_template(dbadm, dbadm_r, dbadm_t)
+')
Index: serefpolicy-contrib-20140730/dbskk.te
===================================================================
--- serefpolicy-contrib-20140730.orig/dbskk.te
+++ serefpolicy-contrib-20140730/dbskk.te
@@ -36,7 +36,6 @@ kernel_read_kernel_sysctls(dbskkd_t)
 kernel_read_system_state(dbskkd_t)
 kernel_read_network_state(dbskkd_t)
 
-corenet_all_recvfrom_unlabeled(dbskkd_t)
 corenet_all_recvfrom_netlabel(dbskkd_t)
 corenet_tcp_sendrecv_generic_if(dbskkd_t)
 corenet_udp_sendrecv_generic_if(dbskkd_t)
@@ -49,10 +48,7 @@ dev_read_urand(dbskkd_t)
 
 fs_getattr_xattr_fs(dbskkd_t)
 
-files_read_etc_files(dbskkd_t)
 
 auth_use_nsswitch(dbskkd_t)
 
 logging_send_syslog_msg(dbskkd_t)
-
-miscfiles_read_localization(dbskkd_t)
Index: serefpolicy-contrib-20140730/dbus.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/dbus.fc
+++ serefpolicy-contrib-20140730/dbus.fc
@@ -1,20 +1,27 @@
-HOME_DIR/\.dbus(/.*)?	gen_context(system_u:object_r:session_dbusd_home_t,s0)
+/etc/dbus-1(/.*)?		gen_context(system_u:object_r:dbusd_etc_t,s0)
 
-/etc/dbus-.*(/.*)?	gen_context(system_u:object_r:dbusd_etc_t,s0)
+/bin/dbus-daemon 	--	gen_context(system_u:object_r:dbusd_exec_t,s0)
 
-/bin/dbus-daemon	--	gen_context(system_u:object_r:dbusd_exec_t,s0)
+ifdef(`distro_redhat',`
+/lib/dbus-1/dbus-daemon-launch-helper -- gen_context(system_u:object_r:dbusd_exec_t,s0)
+/usr/lib/dbus-1/dbus-daemon-launch-helper -- gen_context(system_u:object_r:dbusd_exec_t,s0)
+')
 
-/lib/dbus-.*/dbus-daemon-launch-helper -- gen_context(system_u:object_r:dbusd_exec_t,s0)
+/usr/bin/dbus-daemon(-1)? --	gen_context(system_u:object_r:dbusd_exec_t,s0)
 
-/usr/bin/dbus-daemon(-1)?	--	gen_context(system_u:object_r:dbusd_exec_t,s0)
+ifdef(`distro_debian',`
+/usr/lib/dbus-1.0/dbus-daemon-launch-helper -- gen_context(system_u:object_r:dbusd_exec_t,s0)
+')
 
-/usr/lib/dbus-.*/dbus-daemon-launch-helper	--	gen_context(system_u:object_r:dbusd_exec_t,s0)
+ifdef(`distro_gentoo',`
+/usr/libexec/dbus-daemon-launch-helper -- gen_context(system_u:object_r:dbusd_exec_t,s0)
+')
 
-/usr/libexec/dbus-daemon-launch-helper	--	gen_context(system_u:object_r:dbusd_exec_t,s0)
+/var/lib/dbus(/.*)?		gen_context(system_u:object_r:system_dbusd_var_lib_t,s0)
+/var/cache/ibus(/.*)?     gen_context(system_u:object_r:system_dbusd_var_lib_t,s0)
 
-/var/lib/dbus(/.*)?	gen_context(system_u:object_r:system_dbusd_var_lib_t,s0)
-
-/var/run/dbus(/.*)?	gen_context(system_u:object_r:system_dbusd_var_run_t,s0)
-/var/run/messagebus\.pid	--	gen_context(system_u:object_r:system_dbusd_var_run_t,s0)
+/var/run/dbus(/.*)?		gen_context(system_u:object_r:system_dbusd_var_run_t,s0)
 
+ifdef(`distro_redhat',`
 /var/named/chroot/var/run/dbus(/.*)?	gen_context(system_u:object_r:system_dbusd_var_run_t,s0)
+')
Index: serefpolicy-contrib-20140730/dbus.if
===================================================================
--- serefpolicy-contrib-20140730.orig/dbus.if
+++ serefpolicy-contrib-20140730/dbus.if
@@ -1,4 +1,4 @@
-## <summary>Desktop messaging bus.</summary>
+## <summary>Desktop messaging bus</summary>
 
 ########################################
 ## <summary>
@@ -19,7 +19,24 @@ interface(`dbus_stub',`
 
 ########################################
 ## <summary>
-##	Role access for dbus.
+##	Execute dbus-daemon in the caller domain.
+## </summary>
+## <param name="domain" unused="true">
+##	<summary>
+##	Domain allowed access
+##	</summary>
+## </param>
+#
+interface(`dbus_exec_dbusd',`
+	gen_require(`
+        type dbusd_exec_t;
+	')
+    can_exec($1, dbusd_exec_t)
+')
+
+########################################
+## <summary>
+##	Role access for dbus
 ## </summary>
 ## <param name="role_prefix">
 ##	<summary>
@@ -41,59 +58,68 @@ interface(`dbus_stub',`
 template(`dbus_role_template',`
 	gen_require(`
 		class dbus { send_msg acquire_svc };
-		attribute session_bus_type;
-		type system_dbusd_t, dbusd_exec_t;
-		type session_dbusd_tmp_t, session_dbusd_home_t;
+		attribute dbusd_unconfined, session_bus_type;
+		type system_dbusd_t, session_dbusd_tmp_t, dbusd_exec_t, dbusd_etc_t;
+		type $1_t;
 	')
 
 	##############################
 	#
-	# Declarations
+	# Delcarations
 	#
 
 	type $1_dbusd_t, session_bus_type;
-	domain_type($1_dbusd_t)
-	domain_entry_file($1_dbusd_t, dbusd_exec_t)
+	application_domain($1_dbusd_t, dbusd_exec_t)
 	ubac_constrained($1_dbusd_t)
-
 	role $2 types $1_dbusd_t;
 
+	kernel_read_system_state($1_dbusd_t)
+
+	selinux_get_fs_mount($1_dbusd_t)
+
+	userdom_home_manager($1_dbusd_t)
+
 	##############################
 	#
 	# Local policy
 	#
 
+	# For connecting to the bus
 	allow $3 $1_dbusd_t:unix_stream_socket connectto;
-	allow $3 $1_dbusd_t:dbus { send_msg acquire_svc };
-	allow $3 $1_dbusd_t:fd use;
-	
-	allow $3 system_dbusd_t:dbus { send_msg acquire_svc };
 
-	allow $3 { session_dbusd_home_t session_dbusd_tmp_t }:dir { manage_dir_perms relabel_dir_perms };
-	allow $3 { session_dbusd_home_t session_dbusd_tmp_t }:file { manage_file_perms relabel_file_perms };
-	userdom_user_home_dir_filetrans($3, session_dbusd_home_t, dir, ".dbus")
+	# SE-DBus specific permissions
+	allow { dbusd_unconfined $3 } $1_dbusd_t:dbus { send_msg acquire_svc };
+	allow $3 system_dbusd_t:dbus { send_msg acquire_svc };
 
 	domtrans_pattern($3, dbusd_exec_t, $1_dbusd_t)
 
 	ps_process_pattern($3, $1_dbusd_t)
-	allow $3 $1_dbusd_t:process { ptrace signal_perms };
+	allow $3 $1_dbusd_t:process signal_perms;
 
-	allow $1_dbusd_t $3:process sigkill;
+	tunable_policy(`deny_ptrace',`',`
+		allow $3 $1_dbusd_t:process ptrace;
+	')
 
-	corecmd_bin_domtrans($1_dbusd_t, $3)
-	corecmd_shell_domtrans($1_dbusd_t, $3)
+	# cjp: this seems very broken
+	corecmd_bin_domtrans($1_dbusd_t, $1_t)
+	corecmd_shell_domtrans($1_dbusd_t, $1_t)
+	allow $1_dbusd_t $3:process sigkill;
+	allow $3 $1_dbusd_t:fd use;
+	allow $3 $1_dbusd_t:fifo_file rw_fifo_file_perms;
 
 	auth_use_nsswitch($1_dbusd_t)
 
-	ifdef(`hide_broken_symptoms',`
-		dontaudit $3 $1_dbusd_t:netlink_selinux_socket { read write };
+	logging_send_syslog_msg($1_dbusd_t)
+
+	optional_policy(`
+		mozilla_domtrans_spec($1_dbusd_t, $1_t)
 	')
 ')
 
 #######################################
 ## <summary>
 ##	Template for creating connections to
-##	the system bus.
+##	the system DBUS.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -103,91 +129,84 @@ template(`dbus_role_template',`
 #
 interface(`dbus_system_bus_client',`
 	gen_require(`
-		attribute dbusd_system_bus_client;
-		type system_dbusd_t, system_dbusd_var_run_t, system_dbusd_var_lib_t;
+		type system_dbusd_t, system_dbusd_t;
+		type system_dbusd_var_run_t, system_dbusd_var_lib_t;
 		class dbus send_msg;
+		attribute dbusd_unconfined;
 	')
 
-	typeattribute $1 dbusd_system_bus_client;
-
+	# SE-DBus specific permissions
 	allow $1 { system_dbusd_t self }:dbus send_msg;
-	allow system_dbusd_t $1:dbus send_msg;
+	allow { system_dbusd_t dbusd_unconfined } $1:dbus send_msg;
 
-	files_search_var_lib($1)
 	read_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
+	files_search_var_lib($1)
+
+	dev_read_urand($1)
 
+	# For connecting to the bus
 	files_search_pids($1)
 	stream_connect_pattern($1, system_dbusd_var_run_t, system_dbusd_var_run_t, system_dbusd_t)
-
 	dbus_read_config($1)
 ')
 
 #######################################
 ## <summary>
-##	Acquire service on DBUS
-##	session bus.
+##	Creating connections to specified
+##	DBUS sessions.
 ## </summary>
-## <param name="domain">
+## <param name="role_prefix">
 ##	<summary>
-##	Domain allowed access.
+##	The prefix of the user role (e.g., user
+##	is the prefix for user_r).
 ##	</summary>
 ## </param>
-#
-interface(`dbus_connect_session_bus',`
-	refpolicywarn(`$0($*) has been deprecated, use dbus_connect_all_session_bus() instead.')
-	dbus_connect_all_session_bus($1)
-')
-
-#######################################
-## <summary>
-##	Acquire service on all DBUS
-##	session busses.
-## </summary>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_connect_all_session_bus',`
+interface(`dbus_session_client',`
 	gen_require(`
-		attribute session_bus_type;
-		class dbus acquire_svc;
+		class dbus send_msg;
+		type $1_dbusd_t;
 	')
 
-	allow $1 session_bus_type:dbus acquire_svc;
+	allow $2 $1_dbusd_t:fd use;
+	allow $2 { $1_dbusd_t self }:dbus send_msg;
+	allow $2 $1_dbusd_t:unix_stream_socket connectto;
 ')
 
 #######################################
 ## <summary>
-##	Acquire service on specified
-##	DBUS session bus.
+##	Template for creating connections to
+##	a user DBUS.
 ## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user role (e.g., user
-##	is the prefix for user_r).
-##	</summary>
-## </param>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_connect_spec_session_bus',`
+interface(`dbus_session_bus_client',`
 	gen_require(`
-		type $1_dbusd_t;
-		class dbus acquire_svc;
+		attribute session_bus_type;
+		class dbus send_msg;
 	')
 
-	allow $2 $1_dbusd_t:dbus acquire_svc;
+	# SE-DBus specific permissions
+	allow $1 { session_bus_type self }:dbus send_msg;
+
+	# For connecting to the bus
+	allow $1 session_bus_type:unix_stream_socket connectto;
+
+	allow session_bus_type $1:process sigkill;
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Creating connections to DBUS
-##	session bus.
+##	Send a message the session DBUS.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -195,15 +214,18 @@ interface(`dbus_connect_spec_session_bus
 ##	</summary>
 ## </param>
 #
-interface(`dbus_session_bus_client',`
-	refpolicywarn(`$0($*) has been deprecated, use dbus_all_session_bus_client() instead.')
-	dbus_all_session_bus_client($1)
+interface(`dbus_send_session_bus',`
+	gen_require(`
+		attribute session_bus_type;
+		class dbus send_msg;
+	')
+
+	allow $1 session_bus_type:dbus send_msg;
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Creating connections to all
-##	DBUS session busses.
+##	Read dbus configuration.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -211,57 +233,39 @@ interface(`dbus_session_bus_client',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_all_session_bus_client',`
+interface(`dbus_read_config',`
 	gen_require(`
-		attribute session_bus_type, dbusd_session_bus_client;
-		class dbus send_msg;
+		type dbusd_etc_t;
 	')
 
-	typeattribute $1 dbusd_session_bus_client;
-
-	allow $1 { session_bus_type self }:dbus send_msg;
-	allow session_bus_type $1:dbus send_msg;
-	
-	allow $1 session_bus_type:unix_stream_socket connectto;
-	allow $1 session_bus_type:fd use;
+	allow $1 dbusd_etc_t:dir list_dir_perms;
+	allow $1 dbusd_etc_t:file read_file_perms;
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Creating connections to specified
-##	DBUS session bus.
+##	Read system dbus lib files.
 ## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user role (e.g., user
-##	is the prefix for user_r).
-##	</summary>
-## </param>
 ## <param name="domain">
 ##	<summary>
 ##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_spec_session_bus_client',`
+interface(`dbus_read_lib_files',`
 	gen_require(`
-		attribute dbusd_session_bus_client;
-		type $1_dbusd_t;
-		class dbus send_msg;
+		type system_dbusd_var_lib_t;
 	')
 
-	typeattribute $2 dbusd_session_bus_client;
-
-	allow $2 { $1_dbusd_t self }:dbus send_msg;
-	allow $1_dbusd_t $2:dbus send_msg;
-
-	allow $2 $1_dbusd_t:unix_stream_socket connectto;
-	allow $2 $1_dbusd_t:fd use;
+	files_search_var_lib($1)
+	read_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
+	read_lnk_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Send messages to DBUS session bus.
+##	Create, read, write, and delete
+##	system dbus lib files.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -269,15 +273,19 @@ interface(`dbus_spec_session_bus_client'
 ##	</summary>
 ## </param>
 #
-interface(`dbus_send_session_bus',`
-	refpolicywarn(`$0($*) has been deprecated, use dbus_send_all_session_bus() instead.')
-	dbus_send_all_session_bus($1)
+interface(`dbus_manage_lib_files',`
+	gen_require(`
+		type system_dbusd_var_lib_t;
+	')
+
+	files_search_var_lib($1)
+	manage_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Send messages to all DBUS
-##	session busses.
+##	Connect to the system DBUS
+##	for service (acquire_svc).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -285,44 +293,52 @@ interface(`dbus_send_session_bus',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_send_all_session_bus',`
+interface(`dbus_connect_session_bus',`
 	gen_require(`
 		attribute session_bus_type;
-		class dbus send_msg;
+		class dbus acquire_svc;
 	')
 
-	allow $1 dbus_session_bus_type:dbus send_msg;
+	allow $1 session_bus_type:dbus acquire_svc;
 ')
 
-#######################################
+########################################
 ## <summary>
-##	Send messages to specified
-##	DBUS session busses.
+##	Allow a application domain to be started
+##	by the session dbus.
 ## </summary>
-## <param name="role_prefix">
+## <param name="domain_prefix">
 ##	<summary>
-##	The prefix of the user role (e.g., user
-##	is the prefix for user_r).
+##	User domain prefix to be used.
 ##	</summary>
 ## </param>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Type to be used as a domain.
+##	</summary>
+## </param>
+## <param name="entry_point">
+##	<summary>
+##	Type of the program to be used as an
+##	entry point to this domain.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_send_spec_session_bus',`
+interface(`dbus_session_domain',`
 	gen_require(`
 		type $1_dbusd_t;
-		class dbus send_msg;
 	')
 
-	allow $2 $1_dbusd_t:dbus send_msg;
+	domtrans_pattern($1_dbusd_t, $2, $3)
+
+	dbus_session_bus_client($3)
+	dbus_connect_session_bus($3)
 ')
 
 ########################################
 ## <summary>
-##	Read dbus configuration content.
+##	Connect to the system DBUS
+##	for service (acquire_svc).
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -330,18 +346,18 @@ interface(`dbus_send_spec_session_bus',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_read_config',`
+interface(`dbus_connect_system_bus',`
 	gen_require(`
-		type dbusd_etc_t;
+		type system_dbusd_t;
+		class dbus acquire_svc;
 	')
 
-	allow $1 dbusd_etc_t:dir list_dir_perms;
-	allow $1 dbusd_etc_t:file read_file_perms;
+	allow $1 system_dbusd_t:dbus acquire_svc;
 ')
 
 ########################################
 ## <summary>
-##	Read system dbus lib files.
+##	Send a message on the system DBUS.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -349,20 +365,18 @@ interface(`dbus_read_config',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_read_lib_files',`
+interface(`dbus_send_system_bus',`
 	gen_require(`
-		type system_dbusd_var_lib_t;
+		type system_dbusd_t;
+		class dbus send_msg;
 	')
 
-	files_search_var_lib($1)
-	read_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
-	read_lnk_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
+	allow $1 system_dbusd_t:dbus send_msg;
 ')
 
 ########################################
 ## <summary>
-##	Create, read, write, and delete
-##	system dbus lib files.
+##	Allow unconfined access to the system DBUS.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -370,26 +384,20 @@ interface(`dbus_read_lib_files',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_manage_lib_files',`
+interface(`dbus_system_bus_unconfined',`
 	gen_require(`
-		type system_dbusd_var_lib_t;
+		type system_dbusd_t;
+		class dbus all_dbus_perms;
 	')
 
-	files_search_var_lib($1)
-	manage_files_pattern($1, system_dbusd_var_lib_t, system_dbusd_var_lib_t)
+	allow $1 system_dbusd_t:dbus *;
 ')
 
 ########################################
 ## <summary>
-##	Allow a application domain to be
-##	started by the specified session bus.
+##	Create a domain for processes
+##	which can be started by the system dbus
 ## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user role (e.g., user
-##	is the prefix for user_r).
-##	</summary>
-## </param>
 ## <param name="domain">
 ##	<summary>
 ##	Type to be used as a domain.
@@ -397,81 +405,67 @@ interface(`dbus_manage_lib_files',`
 ## </param>
 ## <param name="entry_point">
 ##	<summary>
-##	Type of the program to be used as an
-##	entry point to this domain.
+##	Type of the program to be used as an entry point to this domain.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_session_domain',`
-	refpolicywarn(`$0($*) has been deprecated, use dbus_all_session_domain() instead.')
-	dbus_all_session_domain($1, $2)
+interface(`dbus_system_domain',`
+	gen_require(`
+		attribute system_bus_type;
+		type system_dbusd_t;
+		role system_r;
+	')
+	typeattribute $1  system_bus_type;
+
+	domain_type($1)
+	domain_entry_file($1, $2)
+
+	domtrans_pattern(system_dbusd_t, $2, $1)
+	init_system_domain($1, $2)
+
+	ps_process_pattern($1, system_dbusd_t)
+
 ')
 
 ########################################
 ## <summary>
-##	Allow a application domain to be
-##	started by the specified session bus.
+##	Use and inherit system DBUS file descriptors.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Type to be used as a domain.
-##	</summary>
-## </param>
-## <param name="entry_point">
-##	<summary>
-##	Type of the program to be used as an
-##	entry point to this domain.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_all_session_domain',`
+interface(`dbus_use_system_bus_fds',`
 	gen_require(`
-		attribute session_bus_type;
+		type system_dbusd_t;
 	')
 
-	domtrans_pattern(session_bus_type, $2, $1)
-
-	dbus_all_session_bus_client($1)
-	dbus_connect_all_session_bus($1)
+	allow $1 system_dbusd_t:fd use;
 ')
 
 ########################################
 ## <summary>
-##	Allow a application domain to be
-##	started by the specified session bus.
+##	Allow unconfined access to the system DBUS.
 ## </summary>
-## <param name="role_prefix">
-##	<summary>
-##	The prefix of the user role (e.g., user
-##	is the prefix for user_r).
-##	</summary>
-## </param>
 ## <param name="domain">
 ##	<summary>
-##	Type to be used as a domain.
-##	</summary>
-## </param>
-## <param name="entry_point">
-##	<summary>
-##	Type of the program to be used as an
-##	entry point to this domain.
+##	Domain allowed access.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_spec_session_domain',`
+interface(`dbus_unconfined',`
 	gen_require(`
-		type $1_dbusd_t;
+		attribute dbusd_unconfined;
 	')
 
-	domtrans_pattern($1_dbusd_t, $3, $2)
-
-	dbus_spec_session_bus_client($1, $2)
-	dbus_connect_spec_session_bus($1, $2)
+	typeattribute $1 dbusd_unconfined;
 ')
 
 ########################################
 ## <summary>
-##	Acquire service on the DBUS system bus.
+##	Delete all dbus pid files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -479,18 +473,18 @@ interface(`dbus_spec_session_domain',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_connect_system_bus',`
+interface(`dbus_delete_pid_files',`
 	gen_require(`
-		type system_dbusd_t;
-		class dbus acquire_svc;
+		type system_dbusd_var_run_t;
 	')
 
-	allow $1 system_dbusd_t:dbus acquire_svc;
+	files_search_pids($1)
+	delete_files_pattern($1, system_dbusd_var_run_t, system_dbusd_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Send messages to the DBUS system bus.
+##	Read all dbus pid files
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -498,98 +492,80 @@ interface(`dbus_connect_system_bus',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_send_system_bus',`
+interface(`dbus_read_pid_files',`
 	gen_require(`
-		type system_dbusd_t;
-		class dbus send_msg;
+		type system_dbusd_var_run_t;
 	')
 
-	allow $1 system_dbusd_t:dbus send_msg;
+	files_search_pids($1)
+	read_files_pattern($1, system_dbusd_var_run_t, system_dbusd_var_run_t)
 ')
 
 ########################################
 ## <summary>
-##	Unconfined access to DBUS system bus.
+##	Do not audit attempts to connect to
+##	session bus types with a unix
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_system_bus_unconfined',`
+interface(`dbus_dontaudit_stream_connect_session_bus',`
 	gen_require(`
-		type system_dbusd_t;
-		class dbus all_dbus_perms;
+		attribute session_bus_type;
 	')
 
-	allow $1 system_dbusd_t:dbus *;
+	dontaudit $1 session_bus_type:unix_stream_socket connectto;
 ')
 
 ########################################
 ## <summary>
-##	Create a domain for processes which
-##	can be started by the DBUS system bus.
+##	Allow attempts to connect to
+##	session bus types with a unix
+##	stream socket.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Type to be used as a domain.
-##	</summary>
-## </param>
-## <param name="entry_point">
-##	<summary>
-##	Type of the program to be used as an entry point to this domain.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_system_domain',`
+interface(`dbus_stream_connect_session_bus',`
 	gen_require(`
-		type system_dbusd_t;
-		role system_r;
+		attribute session_bus_type;
 	')
 
-	domain_type($1)
-	domain_entry_file($1, $2)
-
-	role system_r types $1;
-
-	domtrans_pattern(system_dbusd_t, $2, $1)
-
-	dbus_system_bus_client($1)
-	dbus_connect_system_bus($1)
-
-	ps_process_pattern(system_dbusd_t, $1)
-
-	userdom_read_all_users_state($1)
-
-	ifdef(`hide_broken_symptoms', `
-		dontaudit $1 system_dbusd_t:netlink_selinux_socket { read write };
-	')
+	allow $1 session_bus_type:unix_stream_socket connectto;
 ')
 
 ########################################
 ## <summary>
-##	Use and inherit DBUS system bus
-##	file descriptors.
+##	Do not audit attempts to send dbus
+##	messages to session bus types.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_use_system_bus_fds',`
+interface(`dbus_chat_session_bus',`
 	gen_require(`
-		type system_dbusd_t;
+		attribute session_bus_type;
+		class dbus send_msg;
 	')
 
-	allow $1 system_dbusd_t:fd use;
+	allow $1 session_bus_type:dbus send_msg;
+	allow session_bus_type $1:dbus send_msg;
 ')
 
 ########################################
 ## <summary>
-##	Do not audit attempts to read and
-##	write DBUS system bus TCP sockets.
+##	Do not audit attempts to send dbus
+##	messages to session bus types.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -597,28 +573,49 @@ interface(`dbus_use_system_bus_fds',`
 ##	</summary>
 ## </param>
 #
-interface(`dbus_dontaudit_system_bus_rw_tcp_sockets',`
+interface(`dbus_dontaudit_chat_session_bus',`
 	gen_require(`
-		type system_dbusd_t;
+		attribute session_bus_type;
+		class dbus send_msg;
 	')
 
-	dontaudit $1 system_dbusd_t:tcp_socket { read write };
+	dontaudit $1 session_bus_type:dbus send_msg;
 ')
 
 ########################################
 ## <summary>
-##	Unconfined access to DBUS.
+##	Do not audit attempts to send dbus
+##	messages to system bus types.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
-##	Domain allowed access.
+##	Domain to not audit.
 ##	</summary>
 ## </param>
 #
-interface(`dbus_unconfined',`
+interface(`dbus_dontaudit_chat_system_bus',`
 	gen_require(`
-		attribute dbusd_unconfined;
+		attribute system_bus_type;
+		class dbus send_msg;
 	')
 
-	typeattribute $1 dbusd_unconfined;
+	dontaudit $1 system_bus_type:dbus send_msg;
+	dontaudit system_bus_type $1:dbus send_msg;
+')
+
+#######################################
+## <summary>
+##      Transition to dbus named content
+## </summary>
+## <param name="domain">
+##      <summary>
+##      Domain allowed access.
+##      </summary>
+## </param>
+#
+interface(`dbus_filetrans_named_content_system',`
+    gen_require(`
+        type system_dbusd_var_lib_t;
+    ')
+    files_var_filetrans($1, system_dbusd_var_lib_t, dir, "ibus")
 ')
